SUBROUTINE Read_Geom(input)

!----------------------------------------------------------------------
!  Copyright 2003-2014 Ecole Normale Supérieure de Lyon, 
!  Centre National de la Recherche Scientifique,
!  Université Claude Bernard Lyon 1. All rights reserved.
!
!  This work is registered with the Agency for the Protection of Programs 
!  as IDDN.FR.001.100009.000.S.P.2014.000.30625
!
!  Authors: P. Fleurat-Lessard, P. Dayal
!  Contact: optnpath@gmail.com
!
! This file is part of "Opt'n Path".
!
!  "Opt'n Path" is free software: you can redistribute it and/or modify
!  it under the terms of the GNU Affero General Public License as
!  published by the Free Software Foundation, either version 3 of the License,
!  or (at your option) any later version.
!
!  "Opt'n Path" is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU Affero General Public License for more details.
!
!  You should have received a copy of the GNU Affero General Public License
!  along with "Opt'n Path". If not, see <http://www.gnu.org/licenses/>.
!
! Contact The Office of Technology Licensing, valorisation@ens-lyon.fr,
! for commercial licensing opportunities.
!----------------------------------------------------------------------

  Use VarTypes
  Use Path_module, only : NGeomI
  Use Io_module

  IMPLICIT NONE


  CHARACTER(32), INTENT(IN) :: input    

  LOGICAL :: Debug


  INTERFACE
     function valid(string) result (isValid)
       CHARACTER(*), intent(in) :: string
       logical                  :: isValid
     END function VALID
  END INTERFACE

  debug=valid('Read_geom')
 if (debug) Call Header("Entering Read_Geom")
  if (debug) WRITE(*,*) "Input:",Trim(Input)
  if (debug) WRITE(*,*) "NgeomI:",NGeomI

  SELECT CASE(Input)
  CASE ('XYZ','CART')
     Call ReadGeom_cart
  CASE ('TURBOMOLE')
     Call ReadGeom_turbomole
  CASE ('VASP')
     Call ReadGeom_vasp
  CASE ('SIESTA')
     Call ReadGeom_siesta
  CASE Default
     WRITe(*,*) 'Input=',trim(Input),' UNKNOWN. Stop'
     STOP

  END SELECT


 if (debug) Call Header("Exiting Read_Geom")

END SUBROUTINE Read_Geom
